﻿#NoEnv
SetWorkingDir %A_ScriptDir%
#NoTrayIcon
#InstallKeybdHook
SendMode Input
#SingleInstance off

StartNumber = 1

Gui +LastFound +OwnDialogs
GUI1 := WinExist()

Gui -MaximizeBox
	Gui, color, B0C4DE
	Gui, Font, s9, Tahoma
	
	; Groupbox has spaces to push the groupbox border rightwards.
	Gui, Add, GroupBox, w400 h590 y10 Section, When you press this hotkey:%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%%A_SPACE%
	Gui, Add, Button, xm+390 ym+3 w20 h20 gInfo, ?
	Gui, Add, Hotkey, xs+175 ys-2 w100 h20 vBIND gSetKey, Insert
		
		Gui, Font,, Tahoma
		Gui, Add, GroupBox, xs+20 ys+30 w360 h120 Section, Auto-Incrementer will insert these keystrokes:
			Gui, Font,,Consolas
			Gui, Add, Edit, xp+10 yp+20 w340 h90 vPrefixBox gGuiSubmit
		
		Gui, Font,, Tahoma
		Gui, Add, GroupBox, xs ys+140 w360 h170 Section, Then insert a number:
			Gui, Add, Text, xs+10 ys+20 w340 +Center, Starting at:
			Gui, Font,,Consolas
			Gui, Add, Edit, xp+120 yp+20 w100 Limit5 gGuiSubmit
				Gui, Add, UpDown, Range-9999-9999 vStartNumber gGuiSubmit,
				
			Gui, Font,, Tahoma
			Gui, Add, Text, xs+10 ys+70 w340 +Center, And increasing each time by:
			Gui, Font,,Consolas
			Gui, Add, Edit, xp+120 yp+20 w100 Limit5 gGuiSubmit
				Gui, Add, UpDown, Range-9999-9999 vIncrementAmount gGuiSubmit, 1
				
			Gui, Font,, Tahoma
			Gui, Add, Text, xs+10 ys+120 w340 +Center, And padded with zeroes to a minimum length of:
			Gui, Font,,Consolas
			Gui, Add, Edit, xp+145 yp+20 w50 Limit4 Number gGuiSubmit
				Gui, Add, UpDown, Range1-9999 vMinimumLength gGuiSubmit, 1
		
		Gui, Font,, Tahoma
		Gui, Add, GroupBox, xs ys+190 w360 h120 Section, And finally, insert these keystrokes:
			Gui, Font,,Consolas
			Gui, Add, Edit, xp+10 yp+20 w340 h90 vSuffixBox gGuiSubmit
		
		Gui, Font,, Tahoma
		Gui, Add, GroupBox, xs ys+140 w360 h70 Section, Using this text input method:
			Gui, Add, Radio, xs+20 ys+25 vInputMethod gGuiSubmit, Attempt to send all of it at once.
			Gui, Add, Radio, xs+20 ys+45 Checked gGuiSubmit, Simulate typing the keystrokes.
		
Gui, Show, Autosize, Auto-Incrementer
GuiControl, Focus, PrefixBox
GoSub, UpdateCounter
GoSub, SetKey

Pause::
Break::
	GuiControl,, StartNumber, 1
	GoSub, GuiSubmit
return

GuiSubmit:
	Gui, Submit, NoHide
return

SetKey:
	GoSub, GuiSubmit
	Hotkey,%BIND_old%,DoBind,off UseErrorLevel
	Hotkey,%BIND%,DoBind,on UseErrorLevel
	BIND_old:=BIND
return

DoBind:
	DoBind(PrefixBox)
	
	; Get the length of the number we're about to output.
	; If it's shorter than the minimum length
	; Find the difference, and
	; Append that many zeroes to the front of the number.
	lengthDifference := MinimumLength - StrLen(StartNumber)
	
	if InputMethod = 1
	{
		; SendMode Input
		if lengthDifference > 0
		{
			SendInput {0 %lengthDifference%}
		}
		
		SendInput %StartNumber%
	}
	else
	{
		; SendMode Event
		if lengthDifference > 0
		{
			SendEvent {0 %lengthDifference%}
		}
		
		SendEvent %StartNumber%
	}

	DoBind(SuffixBox)
	
	; Forcing an addition of zero to both of the values below forces AHK to recognise
	; them as integers — without doing this, entering a negative value by hand (-12)
	; would result in the hyphen being ignored and the number being evaluated as +ve.
	StartNumber := (StartNumber += 0) + (IncrementAmount += 0)
	GoSub, UpdateCounter
return

GuiEscape:
	Gui, Show, Minimize
return

GuiClose:
ExitApp

DoBind(MacroBox)
{
	Loop, parse, MacroBox, `n, `r
	{
		; Commenting tag is <// Blahblahblah. Must occur at the start of a line.
		if RegExMatch(A_LoopField, "^<//") = 0
		{
			global InputMethod
			if InputMethod = 1
			{
				SendInput %A_LoopField%
			}
			else
			{
				SendEvent %A_LoopField%
			}
		    
		    ; Custom pause tag is {Wait NUMBER} at any part of a line. It is automatically
		    ; ignored by AHK if it occurs within a macro's text. The pause is applied only
		    ; at the end of the line it is found on.
			if RegExMatch(A_LoopField, "i)\{\s?Wait\s?([0-9]*)\s?\}", PlusDelay) != 0
			{
				Sleep, PlusDelay1
			}
			else
			{
				Sleep, SLEEPTIME
			}
		}
	}
}

UpdateCounter:
	; Send counter value to the edit box control.
	GuiControl,, Edit2, %StartNumber%
return

Info:
MsgBox, 0, About Auto-Incrementer, 
(
You are using Auto-Incrementer v3, released 21 February 2015.
desiquintans.com/incrementer

While Auto-Incrementer is running, you can reset the current count to 1 by pressing Pause/Break (above the Page Up/Down keys).

TIP: You can set negative numbers as the starting value and the incrementing value!

Auto-Incrementer uses the standard Autohotkey 'Send' command's keystrokes, and the additional delay and commenting tags I included in Instant Text Automator.

For more info:
	- autohotkey.com/docs/commands/Send.htm
	- desiquintans.com/automator
)
return